

//	Learn the program codes for the remote.
//	Copyright 1996, 1997 by Chuck Heller.
//	All rights reserved.


#include <stdio.h>
#include <conio.h>
#include <dos.h>

#define DATA_REG			0x3f8
#define INTERRUPT_ENABLE_REG		0x3f9
#define INTERRUPT_IDENTIFICATION_REG	0x3fa
#define LINE_CONTROL_REG		0x3fb
#define MODEM_CONTROL_REG		0x3fc
#define LINE_STATUS_REG			0x3fd
#define MODEM_STATUS_REG		0x3fe

#define Q_LENGTH 1024

char the_q [Q_LENGTH];

#define REPEAT	3
	// This is how many times we want them to repeat pressing the button.

int  	parity = 0,
	overrun = 0,
	frame = 0,
	break_count = 0,
	lost = 0,
	found = 0,
	input_index = 0,
	output_index =0;

static long far * tics = (long far *) 0x0000046c;
long last_activity; // This is the tic count when we last recieved
				// a byte from the remote control.

#include "keys.h"

void (interrupt * old_vector)();

void interrupt serial_isr (void)

{
	char	ch;
	int	temp_index;

	_enable ();
	ch = inp (INTERRUPT_IDENTIFICATION_REG);
	last_activity = *tics;
	switch (ch) {
/*
	    case 6:	// Line status interrupt
		ch = inp (LINE_STATUS_REG);
		if (ch & 4) ++parity;
		if (ch & 2) ++overrun;
		if (ch & 8) ++frame;
		if (ch & 16) ++break_count;
		ch = inp (DATA_REG);
		temp_index = input_index + 1;
		if (temp_index >= Q_LENGTH)
			temp_index = 0;
		if (temp_index != output_index) {
			the_q [temp_index] = ch;
			input_index = temp_index;
			++found;
		} else
			++lost;
		break;
*/
	    case 6:
		ch = inp (LINE_STATUS_REG);
	    case 4:	// receive data available
		ch = inp (DATA_REG);
		temp_index = input_index + 1;
		if (temp_index >= Q_LENGTH)
			temp_index = 0;
		if (temp_index != output_index) {
			the_q [temp_index] = ch;
			input_index = temp_index;
			++found;
		} else
			++lost;
		break;
	    case 0:	// modem status interrupt
		ch = inp (MODEM_STATUS_REG);
		break;
	}
	outp (0x20, 0x20);	// Tell the interrupt controller we are done
}

install ()

{
	char	ch;

	outp (INTERRUPT_ENABLE_REG, 0xd);
	inp  (DATA_REG);
	inp  (LINE_STATUS_REG);
	old_vector = _dos_getvect (12);
	_dos_setvect (12, serial_isr);

	// enable the interrupt controller to give us the interrupt

	ch = inp (0x21);
	ch &= 0xef;	// IRQ mask for IRQ4 11101111
	outp (0x21, ch);

	// enable the serial chip to give us the interrupts

	outp (MODEM_CONTROL_REG, 0xb);
	printf ("install is complete\n");
}

cleanup ()

{
	char	ch;

/*
	outp (INTERRUPT_ENABLE_REG, 0);	// Disable all 8250 interrupts.
	outp (MODEM_CONTROL_REG, 0);	// Turn off more 8250 interrupts.
*/
	// Disable COM1 interrupt
	ch = inp (0x21);
	ch |= ! 0xef;	// IRQ mask for IRQ4 11101111
	outp (0x21, ch);

	_dos_setvect (12, old_vector);
	printf ("cleanup is done\n");
}

delay_hack ()

{
/*
	printf ("last %lx, tics %lx, input %d\n",
			last_activity,
			*tics,
			input_index);
*/
}

main ()

{
	long	times,
		i,
		b;
	FILE	*fp;

	install ();
	atexit (cleanup);
	fp = fopen ("LEARN.TXT", "w");
	if (!fp) {
		fprintf (stderr, "I could not open LEARN.TXT for writing\n");
		exit (1);
	}
	printf ("Copyright 1996, 1997 by Chuck Heller\n");
	printf ("All rights reserved.\n");
	printf ("This program will prompt you to press each button\n");
	printf ("on your remote so that we can learn the codes.\n");
	printf ("We will suggest some buttons to press, but you are free\n");
	printf ("to pick others if you wish.\n");
	for (b = 0 ; buttons[b] ; b++) {
		fprintf (stderr, "Push the %s button %d times\n",
				buttons[b],
				REPEAT);
		fprintf (fp, "%s\n", buttons[b]);
		for (times = 0 ; times < REPEAT ; times++) {
			last_activity = *tics;
			while ((input_index <= 10) || (last_activity + 4 >= *tics))
				delay_hack ();
			for (i = 1 ; i <= input_index  && i < 70 ; i++) {
				fprintf (fp, "%d", !! the_q[i]);
				printf ("%d", !! the_q[i]);
			}
			printf ("\n");
			fprintf (fp, "\n");
			input_index = output_index = 0;	// clear the_q
		}
	}
	fclose (fp);
/*
	while (1) {
		int	ch;

		if (output_index != input_index) {
			int	temp_index;
			static int items_per_line = 0;

			temp_index = output_index + 1;
			if (temp_index >= Q_LENGTH)
				temp_index = 0;
			ch = the_q [temp_index];
			ch &= 0xff;	// I hate sign extension.
			output_index = temp_index;
			printf ("%d ", ! ! ch);
			if (++items_per_line > 38) {
				printf ("\n");
				items_per_line = 0;
			}
		}
			
	}
*/
}

